unit Unit1;

interface

uses Windows, Messages, SysUtils, Classes, dialogs;

   procedure launchProg;
   function AddSeconds(DateVal: TDateTime; NumSecs: Integer): TDateTime;


implementation

procedure launchProg;
var
	strParams, strProgName, strDay, strMonth, strYear, strSecondsToWait: string;
   i, intCommasFound,secondsToWait: integer;
   lpSaveSystemTime, lpFoolSystemTime: PSystemTime;
   savedTime: TDateTime;
begin
	// to use: backintime program.exe,mm,dd,yyyy,resetdelay
	strParams := '';
   for i := 1 to ParamCount do
		strParams := strParams + ParamStr(i);
   intCommasFound := 0;
   strProgName := '';
   strDay := '';
   strMonth := '';
   strYear := '';
   strSecondsToWait := '';
   
   for i := 1 to Length(strParams) do
   begin
   	if copy(strParams, i, 1) = ',' then
      	inc(intCommasFound)
      else
      begin
	      case (intCommasFound) of
				0:strProgName := strProgName + copy(strParams, i, 1);
      	   1:strDay := strDay + copy(strParams, i, 1);
         	2:strMonth := strMonth + copy(strParams, i, 1);
	         3:strYear := strYear + copy(strParams, i, 1);
            4:strSecondsToWait := strSecondsToWait + copy(strParams, i, 1);
   	   end;
      end;
   end;

   if intCommasFound <> 4 then
   begin
      ShowMessage('to use: fooldate program.exe,mm,dd,yyyy,resetdelay');
      exit;
   end;

   try
      try
         // save current system time
  	      lpSaveSystemTime := new(PSystemTime);
	      GetSystemTime(lpSaveSystemTime^);

         // create requested time
         lpFoolSystemTime := new(PSystemTime);
			lpFoolSystemTime^.wYear := StrToInt(strYear);
	    	lpFoolSystemTime^.wMonth := StrToInt(strMonth);
	      // ignore wDayOfWeek
	    	lpFoolSystemTime^.wDay := StrToInt(strDay);
	    	lpFoolSystemTime^.wHour := lpSaveSystemTime^.wHour;
	      lpFoolSystemTime^.wMinute := lpSaveSystemTime^.wMinute;
	      lpFoolSystemTime^.wSecond := lpSaveSystemTime^.wSecond;
	      lpFoolSystemTime^.wMilliseconds := lpSaveSystemTime^.wMilliseconds;

         // set requested time, launch program & wait for program to start
	      SetSystemTime(lpFoolSystemTime^);
	      if WinExec(PChar(strProgName), SW_SHOWDEFAULT) < 31 then ShowMessage('Error running ' + strProgName) ;
         secondsToWait := StrToInt(strSecondsToWait);
         sleep(secondsToWait * 1000);

         // reset system clock to original time, plus the number of seconds we delayed for
         savedTime := SystemTimeToDateTime(lpSaveSystemTime^);
         savedTime := AddSeconds(savedTime, secondsToWait);
         DateTimeToSystemTime(savedTime, lpSaveSystemTime^);
			SetSystemTime(lpSaveSystemTime^);
      finally
   		Dispose(lpFoolSystemTime) ;
		   Dispose(lpSaveSystemTime) ;
   	end;
   except
   	ShowMessage('Exception ' + ExceptObject.ClassName + ' has been raised with message: ' + Exception(ExceptObject).Message) ;
   end;
end;


function AddSeconds(DateVal: TDateTime; NumSecs: Integer): TDateTime;
begin
   //showmessage(datetimetostr(DateVal));
   Result := DateVal + (NumSecs/86400); // 86400 = # of seconds in a day
   //showmessage(datetimetostr(result));
end;


end.
